/*
 * INNOV-2: Build a Better Web Interface Using AJAX
 *
 * ajaxses.p
 *
 * This program generates an xml response to an AJAX request for a list of
 * breakout sessions scheduled for a specific date and time slot.
 */

{cgidefs.i}

Define variable SessionDate  as  date no-undo.
Define variable TimeSlot     as  character no-undo.

assign SessionDate = date(get-value("sdate"))
       TimeSlot    = get-value("ts")
       NO-ERROR.

/*
 *  If we receive an invalid session date, use June 5th.
 */
if SessionDate eq ? then
  assign SessionDate = 06/05/2006.


{&OUT}
  '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' skip
  '<sessions>' skip
  '  <sdate>' SessionDate '</sdate>' skip
  '  <ts>' TimeSlot '</ts>' skip.

/*
 *  In light of the new OO features in 10.1, "class" probably isn't a 
 *  very good name for a table.
 */
for each class where class.classdate eq SessionDate
         and class.classtime eq TimeSlot
         no-lock by class.classid:
  {&OUT}
    "  <session>" Class.ClassID ": " Class.ClassName "</session>" skip.
end.  /**  for each class  **/

{&OUT}
  '</sessions>' skip.

