/*
 * INNOV-2: Build a Better Web Interface Using AJAX
 *
 * ajaxts.p
 *
 * This program generates an xml response to an AJAX request for a list of
 * time slots for breakout sessions scheduled for a specific date .
 */

{cgidefs.i}

Define variable SessionDate  as  date no-undo.

assign SessionDate = date(get-value("sdate"))
       NO-ERROR.

if SessionDate eq ? then
  assign SessionDate = 06/05/2006.


{&OUT}
  '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' skip
  '<timeslots>' skip
  '  <sdate>' SessionDate '</sdate>' skip.

for each class where class.classdate eq SessionDate
         no-lock break by class.classtime:

  if first-of( class.classtime ) then
    {&OUT}
      "  <timeslot>" string( Class.ClassTime, "xx:xx" ) "</timeslot>" skip.
end.  /**  for each class  **/

{&OUT}
  '</timeslots>' skip.

